// XvCȐԃvOTv

#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <tchar.h>
#include "matrix.h"


struct POINT1{
	double x,y;
};


// 2W̃XvCȐNX


class SPLINE{
public:
	double* a;	//	ԂƂ̌W
	double* b;	//	ԂƂ̌W
	double* c;	//	ԂƂ̌W
	double* d;
	int max;
	SPLINE(int n){
		a=new double[n-1];
		b=new double[n-1];
		c=new double[n-1];
		d=new double[n-1];
		max=n;
	}
	~SPLINE(){
		delete [] a;
		delete [] b;
		delete [] c;
		delete [] d;
	}
	void put(int n){
		_tprintf(TEXT("%i,%g,%g,%g,%g\n"),n,a[n],b[n],c[n],d[n]);
	}
	void put(void){
		for(int n=0;n<max-1;n++){
			put(n);
		}

	}
	void coefficient(POINT1* p){	// WꗗW̎ZsB
		MATRIX g(max-3,max-3);
		MATRIX_OWN_COLUMN k(max-3);
		MATRIX_OWN_COLUMN s(max-3);
		double* h=new double[max];
		int i;
		for(i=0;i<max-1;i++){
			h[i]=p[i+1].x-p[i].x;
		}
		h[i]=0;
		for(i=1;i<max-2;i++){
			k[i-1]=6*( (p[i+1].y-p[i].y)/h[i] - (p[i].y-p[i-1].y)/h[i-1]); 
		}
		g.zero();
		for(i=0;i<=max-4;i++){
			if(0<i)
				g[i][i-1]=h[i];
			g[i][i]=2*(h[i+1]+h[i]);
			if(i<max-4)
				g[i][i+1]=h[i+1];
		}
		g.forward_sub(k);
		g.backward_sub(k,s);
		double s0,s1;

		for(i=0;i<=max-2;i++){
			if(i==0){
				s0=0;
				s1=s[i];
			}else if(i==max-3){
				s0=s[i-1];
				s1=0;
			}else if(i==max-2){
				s0=0;
				s1=0;
			}else{
				s0=s[i-1];
				s1=s[i];
			}
			a[i]=(s1-s0)/(6.0f*(p[i+1].x-p[i].x));
			b[i]=s0/2.0f;
			c[i]=(p[i+1].y-p[i].y)/(p[i+1].x-p[i].x)-(p[i+1].x-p[i].x)/6.0f*(2.0f*s0+s1);
			d[i]=p[i].y;
		}
		delete h;
	}
	double interpolation(POINT1* p,double x,int n){	//	w肵Ԃdx=x-xnɑ΂Ԓl
		return a[n]*x*x*x + b[n]*x*x + c[n]*x + d[n];
	}
	void interpolation(POINT1* pb,POINT1* p,int d){		// ԂdĕԒl̍Wꗗ쐬pɕۑ
		int i;
		int u=0;
		for(i=0;i<max-1;i++){
			double dx,x;
			x=0;
			dx=pb[i+1].x-pb[i].x;
			for(int o=0;o<d;o++){
				p[u].x=pb[i].x+x;
				p[u].y=interpolation(pb,x,i);
				++u;
				x+=dx/double(d);
			}
			p[u].x=pb[i+1].x;
			p[u].y=pb[i+1].y;
		}

	}
};


#define NMAX 6	//	̓f[^[
#define HMAX 4 //  Ԃ̕

//	͍W

POINT1 sp2[]={{	  2041.68,	1575.59 },
				{ 2830.84,	2298.99 },
				{ 3685.07,	1900.71 },
				{ 4191.15,	1353.67 },
				{ 4889.14,	1648.74 },
				{ 5403.39,	2536.84 }};


POINT1 p[NMAX*HMAX+1]; // ԂꂽWۑ


void main(void){
	int i;
	_tprintf(TEXT("input data\n"));
	_tprintf(TEXT("n,xn,yn\n"));
	POINT1 sp[NMAX];

	for(i=0 ; i<NMAX ; i++){

		sp[i].y=sp2[i].y;
		sp[i].x=sp2[i].x;
		_tprintf(TEXT("%i,%g,%g\n"),i,sp[i].x,sp[i].y);
	}

	SPLINE s(NMAX);
	s.coefficient(sp);
	_tprintf(TEXT("\ncoefficient\ny=an*(x-xn)^3+bn*(x-xn)^2+cn*(x-xn)+dn\n"));
	_tprintf(TEXT("n,an,bn,cn,dn\n"));
	s.put();
	s.interpolation(sp,p,HMAX);
	_tprintf(TEXT("\ninterpolation\n"));
	_tprintf(TEXT("No,xn,yn\n"));
	for(i=0 ; i<(NMAX-1)*HMAX+1 ; i++){
		_tprintf(TEXT("%i,%g,%g\n"),i,p[i].x,p[i].y);
	}
}
